{$apptype console}

// (C) Chistyakov T. S. 2006
{$O-}

uses
  SysUtils, Types;
  
type
  TFrom = (fNorth, fEast, fSouth, fWest);

var
  msg: string;
  n: integer;
  ss, ee: array of TIntegerDynArray;

function checkSol(var f: textfile; out NumSteps: integer): integer;
const
  DIR_X: array [TFrom] of integer = (0, 1, 0, -1);
  DIR_Y: array [TFrom] of integer = (-1, 0, 1, 0);
  ANT: array [TFrom] of TFrom = (fSouth, fWest, fNorth, fEast);
var
  col, row, pCol, pRow: integer;
  idir, pFrom, dir: TFrom;
  ok: boolean;
begin
  NumSteps := 0;
  read(f, col);
  if (col = 0) then begin
    if SeekEof(f) then begin
      Result := 0;
      Exit;
    end
    else begin
      msg := 'something after first 0';
      Result := 2;
      Exit;
    end;
  end;
  read(f, row);
  if (col <> 1) or (row <> 1) then begin
    msg := 'first pair is not 1 1';
    Result := 1;
    Exit;
  end;

  dir := fNorth;
  while not SeekEof(f) do begin
    pCol := col;
    pRow := row;
    read(f, col, row);
    Inc(NumSteps);
    if (col < 1) or (row < 1) or (col > n) or (row > n) then begin
      msg := 'col/row out of range';
      Result := 2;
      Exit;
    end;
    pFrom := ANT[dir];
    dir := fNorth;
    ok := false;
    for idir := Low(idir) to High(idir) do
      if (col - pCol =  DIR_X[idir]) and (row - pRow = DIR_Y[idir]) then begin
        ok := true;
        dir := idir;
        Break;
      end;
    if not ok then begin
      msg := 'move not allowed at all';
      Result := 1;
      Exit;
    end;

    case dir of
      fNorth:
        ok :=
          (ss[pRow - 1, pCol] in [2, 4]) and
          not ((pFrom = fWest) and (ee[pRow, pCol - 1] = 1)) and
          not ((pFrom = fEast) and (ee[pRow, pCol] = 2));
      fEast:
        ok :=
          (ee[pRow, pCol] in [1, 3]) and
          not ((pFrom = fNorth) and (ss[pRow - 1, pCol] = 1)) and
          not ((pFrom = fSouth) and (ss[pRow, pCol] = 2));
      fSouth:
        ok :=
          (ss[pRow, pCol] in [1, 3]) and
          not ((pFrom = fWest) and (ee[pRow, pCol - 1] = 3)) and
          not ((pFrom = fEast) and (ee[pRow, pCol] = 4));
      fWest:
        ok :=
          (ee[pRow, pCol - 1] in [2, 4]) and
          not ((pFrom = fNorth) and (ss[pRow - 1, pCol] = 3)) and
          not ((pFrom = fSouth) and (ss[pRow, pCol] = 4));
    end;
    if not ok then begin
      msg := 'move not allowed due to doors';
      Result := 1;
      Exit;
    end;
  end;
  if (col = n) and (row = n) then
    Result := 0
  else begin
    msg := 'last pair is not N N';
    Result := 1;
  end;
end;

var
  fi, fo, fa: textfile;
  outr, ansr: integer;
  osteps, asteps: integer;
  i, j: integer;
begin
  assignfile(fi, paramstr(1));
  assignfile(fo, paramstr(2));
  assignfile(fa, paramstr(3));
  reset(fi);
  reset(fo);
  reset(fa);
  try
    try
      read(fi, n);
      SetLength(ss, n + 2, n + 2);
      SetLength(ee, n + 2, n + 2);
      for i := 1 to n do
        for j := 1 to n do 
          read(fi, ee[i, j], ss[i, j]);
      ansr := checkSol(fa, asteps);
      outr := checkSol(fo, osteps);
      if ansr <> 0 then begin
        Writeln(msg);
        Halt(4);
      end;
      if outr <> 0 then begin
        Writeln(msg);
        Halt(outr);
      end;
      if (asteps = 0) and (osteps <> 0) then begin
        WriteLn('answer is impossible, while solution found');
        Halt(4);
      end;
      if (asteps <> 0) and (osteps = 0) then begin
        WriteLn('answer is possible, while output says it''s not');
        Halt(1);
      end;
      if (asteps < osteps) then begin
        WriteLn('output is worse than answer ', osteps, ' ', asteps);
        Halt(1);
      end;
      if (asteps > osteps) then begin
        WriteLn('answer is worse than output ', asteps, ' ', osteps);
        Halt(4);
      end;
    except
      on E: Exception do begin
        WriteLn(E.Message);
        Halt(2);
      end;
    end;
  finally
    closefile(fa);
    closefile(fo);
    closefile(fi);
  end;
  writeln('ok');
end.
