{$apptype console}

// (C) Chistyakov T. S. 2006

uses
  Classes, Types, SysUtils;

type
  TFrom = (fNorth, fEast, fSouth, fWest);
  PQueueItem = ^TQueueItem;
  TQueueItem = record
    Row, Col: integer;
    From: TFrom;
    Prev: PQueueItem;
    Next: PQueueItem;
  end;

var
  n: integer;
  vis: array [TFrom] of array of TBooleanDynArray;
  head: PQueueItem = nil;
  tail: PQueueItem = nil;
  corner: PQueueItem = nil;
  ok: boolean = false;

procedure go(ARow, ACol: integer; AFrom: TFrom);
var
  c: PQueueItem;
begin
  if not vis[AFrom, ARow, ACol] then begin
    vis[AFrom, ARow, ACol] := true;
    New(c);
    with c^ do begin
      Row := ARow;
      Col := ACol;
      From := AFrom;
      Prev := head;
      Next := nil;
    end;
    if tail <> nil then 
      tail^.Next := c
    else
      head := c;
    tail := c;
    if not ok and (ARow = n) and (ACol = n) then begin
      corner := c;
      ok := true;
    end;
  end;
end;


var
  fi, fo: textfile;
  ss, ee: array of TIntegerDynArray;
  i, j: integer;
  f: TFrom;
  c: PQueueItem;
  sl: TStringList;
begin
  assignfile(fi, 'input.txt');
  reset(fi);
  assignfile(fo, 'output.txt');
  rewrite(fo);

  read(fi, n);
  assert((n >= 1) and (n <= 1000));
  SetLength(ss, n + 2, n + 2);
  SetLength(ee, n + 2, n + 2);
  for f := Low(f) to High(f) do begin
    SetLength(vis[f], n + 2, n + 2);
    for i := 0 to n + 1 do
      for j := 0 to n + 1 do begin
        ss[i, j] := 0;
        ee[i, j] := 0;
        vis[f, i, j] := false;
      end;
  end;

  for i := 1 to n do
    for j := 1 to n do begin
      read(fi, ee[i, j], ss[i, j]);
      assert((ee[i, j] >= 0) and (ee[i, j] <= 4));
      assert((ss[i, j] >= 0) and (ss[i, j] <= 4));
      assert((i < n) xor (ss[i, j] = 0));
      assert((j < n) xor (ee[i, j] = 0));
    end;

  go(1, 1, fNorth);

  while head <> nil do begin
    // fNorth, fEast, fSouth, fWest
    with head^ do begin
      //   
      if
        (Row > 1) and
        (ss[Row - 1, Col] in [2, 4]) and
        not ((From = fWest) and (ee[Row, Col - 1] = 1)) and
        not ((From = fEast) and (ee[Row, Col] = 2))
      then
        go(Row - 1, Col, fSouth);

      //   
      if
        (Col > 1) and
        (ee[Row, Col - 1] in [2, 4]) and
        not ((From = fNorth) and (ss[Row - 1, Col] = 3)) and
        not ((From = fSouth) and (ss[Row, Col] = 4))
      then
        go(Row, Col - 1, fEast);

      //   
      if
        (Row < n) and
        (ss[Row, Col] in [1, 3]) and
        not ((From = fWest) and (ee[Row, Col - 1] = 3)) and
        not ((From = fEast) and (ee[Row, Col] = 4))
      then
        go(Row + 1, Col, fNorth);

      // 
      if
        (Col < n) and
        (ee[Row, Col] in [1, 3]) and
        not ((From = fNorth) and (ss[Row - 1, Col] = 1)) and
        not ((From = fSouth) and (ss[Row, Col] = 2))
      then
        go(Row, Col + 1, fWest);
    end;
    if ok then
      Break;
    head := head^.Next;
  end;

  if not ok then
    write(fo, 0)
  else begin
    sl := TStringList.Create;
    try
      c := corner;
      while c <> nil do begin
        sl.Add(Format('%d %d', [c^.Col, c^.Row]));
        c := c^.Prev;
      end;
      for i := sl.Count - 1 downto 0 do
        writeln(fo, sl[i]);
    finally
      sl.Free;
    end;
  end;

  closefile(fo);
  closefile(fi);
end.
